package papershredderwrapper;

import main.java.com.ldoublem.PaperShredderlib.PaperShredderView;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
//import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;
//import android.view.MotionEvent;

//import android.graphics.Color;
//import android.graphics.Typeface;

import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;
//import android.view.Gravity; 

//import android.util.Log;
//import android.view.ViewTreeObserver;

//import android.media.AudioFormat;
//import android.media.AudioRecord;
//import android.media.MediaRecorder;

import java.util.ArrayList;
import java.util.List;
import java.util.Arrays;
import java.util.HashMap;

//import android.os.Build;
import android.os.Bundle;

import android.os.Handler;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.view.MotionEvent;
import android.view.View.OnTouchListener;

import android.graphics.Color;



//@ActivityObject
//@Events(values={"wheel_clicked(position As Int)", "item_selected(position As Int)"})
@Author("Github: ldoublem (https://github.com/ldoublem/PaperShredder), Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("PaperShredder")
//@DependsOn(values={"android-support-v4"})
public class papershredderWrapper extends ViewWrapper<PaperShredderView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private PaperShredderView cv;
    int i = 1;
	

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new PaperShredderView(ba.context);
        this.setObject(cv);
		
        cv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (i == 1)
                    cv.startAnim(duration);
                else
                    cv.stopAnim();
                i = i * -1;
            }
        });		

 	}
	
			

    public void setShredderTitle(String title) {
        cv.setTitle(title);
		cv.invalidate();
    }

			
	public int SHRED_TYPE_SLIP = 0;
    public int SHRED_TYPE_PIECE = 1;
    public void setShrededType(int shredtype) {
        if (shredtype == 0) cv.setShrededType(PaperShredderView.SHREDEDTYPE.Slip);
        if (shredtype == 1) cv.setShrededType(PaperShredderView.SHREDEDTYPE.Piece);		
		cv.invalidate();
    }
	

    public void setSherderProgress(boolean show) {
        cv.setSherderProgress(show);
		cv.invalidate();
    }

    public void setShredderTextColor(int color) {
        cv.setTextColor(color);
        cv.invalidate();

    }

    public void setShredderBgColor(int color) {
        cv.setBgColor(color);
        cv.invalidate();
    }

    public void setPaperColor(int color) {
        cv.setPaperColor(color);
        cv.invalidate();
    }

    public void setTextShadow(boolean show) {
        cv.setTextShadow(show);
        cv.invalidate();
    }

    public void setPaperEnterColor(int color) {
        cv.setPaperEnterColor(color);
		cv.invalidate();
    }

	
	private int duration = 2000;
    public void startAnim(int duration) {
		this.duration = duration;
        cv.startAnim(duration);
		cv.invalidate();
    }


    public void stopAnim() {
        cv.stopAnim();
        cv.invalidate();

    }	

				
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	

   
}
